/* eslint-disable @typescript-eslint/no-unsafe-call */
import dynamic from 'next/dynamic';
import withHydrationOnDemand from './lazy-hydrate';
const defaultVisibleOption = () => ({
    rootMargin: '50px',
});
let moduleId = 0; // Static counter
export default function lazyLoadHydrate(module, option = {
    on: [['visible', defaultVisibleOption]],
}) {
    moduleId++;
    return withHydrationOnDemand({
        on: option.on,
        onBefore: module,
        wrapperProps: Object.assign(Object.assign({}, option.wrapperProps), { 'data-hydration-id': moduleId }),
    })(dynamic(module, {
        loading: () => {
            var _a;
            const componentHTML = (_a = window.document.querySelector(`[data-hydration-id=${moduleId}]`)) === null || _a === void 0 ? void 0 : _a.innerHTML;
            if (!componentHTML) {
                return null;
            }
            return (<div suppressHydrationWarning dangerouslySetInnerHTML={{ __html: componentHTML }}/>);
        },
        ssr: true,
    }));
}
